* Detailed fields
g byte field_det = .
replace field_det = 0 if utdtype=="EXPHIL"
replace field_det = 1 if inlist(utdomr,"REALFAG") & !inlist(utdtype,"SAMVIT","R-LRER","HISTFIL","KUNSTFAG","INGENIR","SIVING") //science
replace field_det = 2 if (inlist(utdomr,"INFOTEKN") & !inlist(utdtype,"SAMVIT","R-LRER","HISTFIL","KUNSTFAG","INGENIR","SIVING")) | (utdtype=="H2-KAND" & inlist(substr(studiekortnavn,1,4),"Data","Info","268","270","379")) //comp.science
replace field_det = 3 if utdtype=="INGENIR" | (utdtype=="H3-KAND" & utdomr=="TEKNO") // engineering
replace field_det = 4 if (inlist(utdtype,"H2-KAND","H3-KAND","R","ANNEN") & utdomr=="KADM") | (utdtype=="H2-KAND" & substr(studiekortnavn,1,2)=="k") | (utdtype=="H2-KAND" & inlist(studiekortnavn,"035","337","402","Personalledelse","Eksportmarkedsfring") )  // commerce except sivk
replace field_det = 5 if utdtype=="SIVKON" // business
replace field_det = 6 if (utdtype=="SAMVIT" | (inlist(utdtype,"H2-KAND","H3-KAND","R","ANNEN","EXPHIL","PNE") & utdomr=="SAMFUNN")) & utdomr!="LRER" // soc sci excl law/criminology, psychology, journalism
replace field_det = 7 if (utdtype=="R" & utdomr=="JUS") | (utdtype=="JUS" & utdomr=="SAMFUNN") // law/criminology
replace field_det = 8 if (utdomr=="SAMFUNN" & word(studiekortnavn,1)=="Psykologi") // psychology
replace field_det = 9 if utdtype=="JOURNAL" // journalism
replace field_det =10 if utdtype=="ALMLRER" // teachers college
replace field_det =11 if utdtype=="FAGLRER" // teacher (special subjects)
replace field_det =12 if utdtype=="FRLRER" // kindergarten teacher
replace field_det =13 if utdtype=="R-LRER" // one-year units for teachers
replace field_det =14 if utdomr=="LRER" & !inrange(field_det,10,13) // other teaching
replace field_det =32 if utdtype=="R" & utdomr=="PEDFAG" // one-year pedagogy
replace field_det =15 if (inlist(utdtype,"HISTFIL","MUSIKK","KUNSTFAG") | (inlist(utdtype,"H2-KAND","H3-KAND","R") & inlist(utdomr,"ESTETISK","HISTORIE"))) & utdomr!="LRER" // humanities, except one-year and languages
replace field_det =16 if (inlist(utdtype,"HISTFIL","H2-KAND","H3-KAND","R","EXPHIL") & inlist(utdomr,"SPRK"))  &  utdomr!="LRER" // langueages
replace field_det =19 if utdtype=="BARNEVER" // child welfare
replace field_det =20 if utdtype=="SOSIONOM" // social work
replace field_det =21 if utdtype=="AUDIO" // audiograph
replace field_det =22 if utdtype=="BIOING" // bio engineering
replace field_det =23 if utdtype=="ERGO" // ergotherapy
replace field_det =24 if utdtype=="FYSIO" // phusiotherapy
replace field_det =25 if utdtype=="SYKEPL" // nurse
replace field_det =26 if utdtype=="VERNEPL" // psych. nurse
replace field_det =27 if utdomr=="HELSEFAG" & field_det == . & !inlist(kompregelkode,"FARMA","MEROD","VETE") // other health
replace field_det =28 if utdomr=="REISELIV" // tourism
replace field_det =29 if utdomr=="LANDBRUK" | utdtype=="LANDBRUK" // agriculture 
replace field_det =30 if utdomr=="MEDIEFAG" & field_det==. // media
replace field_det =31 if utdomr=="IDRETT" & field_det==. // sports

replace field_det =41 if utdtype=="SIVING" // civil eng
replace field_det =42 if utdtype=="JUS" & utdomr=="JUS" // law
replace field_det =43 if utdtype=="MEDISIN" // medicine
replace field_det =44 if utdtype=="ODONT" & inlist(kompregelkode,"MEROD","ODLO","ODOB") // dentistry
replace field_det =45 if utdtype=="FARMASI" // pharmaceutical science
replace field_det =46 if utdomr=="HELSEFAG" & field_det==. & inlist(kompregelkode,"MEROD","VETE","FARMA") // other graduate healh
replace field_det =47 if utdtype=="ARKITEKT"

replace field_det =99 if studie==0
replace field_det =90 if field_det==.

* Aggregate fields
g byte field_agg = .
replace field_agg = 0 if inlist(field_det,0) // ex.phil
replace field_agg = 1 if inlist(field_det,1,2,29) // sci
replace field_agg = 2 if inlist(field_det,3,41,47) // engineering
replace field_agg = 3 if inlist(field_det,4,5,28) // commerce
replace field_agg = 4 if inlist(field_det,6,7,8,9) // soc.sci
replace field_agg = 5 if inlist(field_det,10,11,12,13,14,32) // teaching
replace field_agg = 6 if inlist(field_det,15,16,17,18,30) // humanities
replace field_agg = 8 if inlist(field_det,19,20,21,22,23,24,25,26,27,31,43,44,45,46) // health
replace field_agg =42 if inlist(field_det,41,47)
replace field_agg =44 if inlist(field_det,42)
replace field_agg =48 if inlist(field_det,43,44,45)

replace field_agg =90 if field_det==90
replace field_agg =99 if studie==0 

do ${prog}vlabels
                     
lab val field_det field_det
lab val field_agg field_agg

g nodur = inlist(utdtype,"HISTFIL","JUS"/*?*/,"REALFAG","SAMVIT","TEOLOGI")
g duration = 1*inlist(utdtype,"R","R-LRER") ///
             +2*inlist(utdtype,"H2-KAND","JOURNAL","AUDIO") ///
             +3*inlist(utdtype,"H3-KAND","SOSIONOM","BARNEVER","BIBLIO","BIOING","ERGO") ///
             +3*inlist(utdtype,"FAGLRER" /*?*/,"FYSIO","FRLRER","INGENIR" /*?*/,"MARITIM","RADIO","RESEPTAR" /*?*/,"SYKEPL","VERNEPL") ///
             +4*inlist(utdtype,"ALMLRER","ERNRING" /*?*/,"SIVKON") ///
             +5*inlist(utdtype,"FARMASI","FISKERI","LANDBRUK","ODONT","SIVARK","ARKITEKT" /*?*/,"SIVING") ///
             +6*inlist(utdtype,"MEDISIN" /*?*/) ///
             if !nodur & utdtype!="EXPHIL"
replace duration = 2 if utdtype=="ODONT" & kompregelkode=="GENS"
replace duration = 3 if utdtype=="ODONT" & kompregelkode=="TANN"
replace duration = 1 if utdtype=="VETERIN" & kompregelkode=="DYRP"
replace duration = 6 if utdtype=="VETERIN" & kompregelkode=="VETE"
replace duration = 3 if nodur & inlist(field_agg,1,4,6)
replace duration = 5 if nodur & inlist(field_agg,44)

egen mode = mode(duration) ,by(field_det) max
replace duration = mode if duration==.
drop nodur mode 
