local earndata /ssb/ursus/a1/finnut/wk48/raw/s225/
local nudbdata /ssb/ursus/a1/finnut/wk48/raw/s360/nudb/
local edudata  /ssb/ursus/a1/finnut/wk48/raw/s360/befutd_nudb/


// Organises earnings data
use fnr wyrkinnt_* using `earndata'inntekter_1993_2013.dta,clear
keep fnr wyrkinnt_1993-wyrkinnt_2013
reshape long wyrkinnt ,i(fnr) j(aar) str
g int tellaar = real(substr(aar,2,.))
drop aar
sort fnr tellaar 
tempfile earnings
save `earnings' ,replace


// Organises data on educational attainment
use loepenr_kurs hskode using `nudbdata'f_utd_kurs ,clear
drop if hskode==""
bysort loepenr_kurs (hskode): keep if _n==1
rename loepenr_kurs bu_loepenr_kurs

merge 1:m bu_loepenr_kurs using `nudbdata'f_utd_demografi ///
	,keep(3) keepusing(fnr bu bu_regdato) nogen
rename bu_regdato efulldato 
rename bu bu_nus2000
rename bu_loepenr_kurs loepenr_kurs

bysort fnr efulldato  bu_nus2000 (hskode loepenr_kurs): keep if _n==1
tempfile inst
save `inst' ,replace


local eduvars fnr bu_* efulldato // igang_nus2000
use `eduvars' using `edudata'befutd_nudb1993 ,clear
g int tellaar =1993
forvalues a=1994/2013 {
  append using `edudata'befutd_nudb`a' ,keep(`nudbvars')
  replace tellaar=`a' if tellaar==.
}
sort fnr tellaar

lab var bu_nus2000  "Highest completed education (NUS2000 classification)"
lab var bu_kltrinn  "Nominal duration of highest compl educ"
lab var bu_uhgruppe "UH classification of highest compl educ"
lab var efulldato   "Month of completing highest compl educ (YYYYMM)"

destring efulldato ,replace
merge m:1 fnr efulldato bu_nus2000 using `inst' ,keepusing(hskode) keep(1 3) nogen

run ${prog}classify_completed
keep fnr tellaar efulldato bu_nus2000 bu_kltrinn hskode field_*

merge 1:1 fnr tellaar using `earnings' ,nogen
compress

save data_outcomes ,replace
