* Table III
use soknad_full ,clear
drop if studie==0
rename pri rank
g offer = tilbud=="S"

foreach v of varlist field_* studie inst {
	bysort fnr year `v': g n_`v' =_n==1
}
egen r_offer = min(cond(offer,rank,.)) ,by(fnr year)
forvalues i =1/3 {
	g d_r`i' = offer & (rank==`i')
}
egen d_nooffer = max(offer) ,by(fnr year)
replace d_nooffer = d_nooffer!=1

collapse (sum) n_* (max) r_offer d_r? d_nooffer ///
	age female gpa f8yrc f8field_comp_agg immpar mor_highed far_highed far_earnings ,by(fnr year)

merge 1:1 fnr using data ,nogen
replace sample = 0 if sample==.

qui su gpa if sample==1
qui replace gpa = (gpa-r(mean))/r(sd)

levelsof inst_pred if inst_pred<99 ,local(ips) sep(",")
replace inst_compl = 99 if !inlist(inst_compl,`ips')

local vars age female gpa f8yrc immpar mor_highed far_highed far_earnings ///
	n_field_agg n_inst r_offer d_r1 d_r2 d_r3 d_nooffer 

qui estpost summ `vars' if sample==1
est sto sample
qui estpost summ `vars' 
est sto all 
noi esttab sample all ,cells("mean(fmt(2)) sd(par)") mti("Sample" "All") lab ti("Table III")

* Figure II
expand 1+sample
bysort fnr: replace sample =_n-1

local a f8field_comp_agg
local b inst_compl

egen n_sample = sum(sample) ,by(inst_compl)
replace inst_compl = 99 if n_sample<1000

foreach x in a b {
	recode ``x'' (. = 99) 
	qui foreach s in 0 1 {
		reg f8yrc ib(999).``x'' ib(2002).year if sample==`s' ,nocons
		est sto earn_`x'_`s'
	}
	estout earn_`x'* ,cell(b) keep(*``x'') drop(0.``x'' 9?.``x'' 999b.``x'' ,relax)
	mat ret = r(coefs)
	svmat ret 
	scatter ret1 ret2 ret2 ,sort c(i l) m(oh i) legend(off) name(Fig_II`x',replace) ///  mlab(f)
		xsize(5) ysize(5) aspect(1)  xla(40(10)90) yla(40(10)90) ///
		xti("Mean earnings in USD 1,000, sample") yti("Mean earnings in USD 1,000, all applicants") 
	drop ret?
}

* Figure I
use data ,clear

collapse (sum) n= sample if !missing(f1,f0) ,by(f1 f0)

bysort f1 (n): replace f0 = 90 if _N-_n>1
collapse (sum) n if !missing(f1,f0) ,by(f1 f0)
lab val f0 field_agg
egen tot = sum(n) ,by(f1) 
g sh = n/tot
reshape wide sh n tot,i(f1) j(f0)
foreach var of varlist sh* {
	local n = substr("`var'",3,.)
	lab var `var' `"`:lab field_agg `n''"'
}
graph hbar (asis) sh* ,over(f1) stack legend(off) /// bar(1,fcol(gs12) lcol(gs1) lwi(medium) lpat(solid)) ///
	blab(name, pos(center) col(black)) yti(Share of applicants) l1ti(Preferred field) name(Fig_I,replace)
