cap prog drop Robustness 
prog define Robustness
	use `1' ,clear
	ds f f0 ,not
	rename (`r(varlist)') =X
	
	merge 1:1 f f0 using `2'
	
	Plot bX b [aw=1/(seX^2+se^2)] `"`3'"'
end

cap prog drop Plot
prog define Plot 
	reg `1' `2' `3' 
	predict hat 
	corr `1' `2' `3'
	twoway (line hat `2' `2'  ,lp(solid dash) sort) (scatter `1' `2' `3' ,m(oh)) ///
		if max(abs(`1'),abs(`2'))<150 ,aspect(1) xla(-150(50)150) yla(-150(50)150) ///
		legend(off) note("corr=`:di %5.3f r(rho)'") `4'
end

* Figure VIII, IX
use res_baseline,clear
kdensity b [aw=Ncomp] if abs(b)<100 ,name(Fig_VIII, replace) 

graph hbar b [aw=Ncomp] ,over(f ,sort(1)) name(Fig_IX, replace) 

* Figure VII 
rename f f1
collapse (sum) n= Ncomp if !missing(f1,f0) ,by(f1 f0)

bysort f1 (n): replace f0 = 90 if _N-_n>1
collapse (sum) n if !missing(f1,f0) ,by(f1 f0)
lab val f0 field_agg
egen tot = sum(n) ,by(f1) 
g sh = n/tot
reshape wide sh n tot,i(f1) j(f0)
foreach var of varlist sh* {
	local n = substr("`var'",3,.)
	lab var `var' `"`:lab field_agg `n''"'
}
graph hbar (asis) sh* ,over(f1) stack legend(off) /// bar(1,fcol(gs12) lcol(gs1) lwi(medium) lpat(solid)) ///
	blab(name, pos(center) col(black)) yti(Share of compliers) l1ti(Completed field) name(Fig_VII,replace)


* Figure XI
est use res_institutions 
local is 42.inst_compl 47.inst_compl 9.inst_compl 46.inst_compl 21.inst_compl 20.inst_compl 11.inst_compl 22.inst_compl 23.inst_compl 38.inst_compl 
coefplot . ,keep(`is') order(`is') xla(-20(20)60) xli(0) name(Fig_XI ,replace)


* Figure XII and BVII
use res_log_inst,clear
keep f f0 b
rename b b_i
merge 1:1 f f0 using res_logearnings 
keep f f0 b b_i Ncomp
tempfile file
save `file'
rename (f f0 b b_i Ncomp) (f0 f b0 b_i0 Ncomp0)
merge 1:1 f f0 using `file'
g d = b+b0
g d_i = b_i+b_i0
g n = Ncomp+Ncomp0
kdensity d [aw=n] if abs(d)<2 ,name(Fig_XII ,replace)
 
twoway (kdensity d [aw=n] if abs(d)<2) ///
	(kdensity d_i [aw=n] if abs(d_i)<2) ,xli(0) name(Fig_BVIIb,replace)

use res_institutions,clear
keep f f0 b
rename b b_i
merge 1:1 f f0 using res_baseline 
twoway (kdensity b [aw=Ncomp] if abs(b)<100) ///
	(kdensity b_i [aw=Ncomp] if abs(b_i)<100) ,xli(0) name(Fig_BVIIa,replace)


* Figures Xb, BI, BVI and BIV
Robustness res_nocollege res_baseline name(Fig_Xb,replace)
Robustness res_peers res_baseline name(Fig_BIa,replace)
Robustness res_exp res_baseline name(Fig_BIb,replace)
Robustness res_institutions res_baseline name(Fig_BVI,replace)

use res_baseline ,clear
Plot bred b [aw=1/(sered^2+se^2)] name(Fig_BIV,replace)
