cap program drop EstSave 
program def EstSave 
	syntax using/ [,replace y0 n]
	
	preserve
	
	local y `e(depvar)'
	local t `e(instd)'
	local x `e(exogr)'
	local z `e(insts)'
	local z : list z -x
	
	keep if e(sample)
	
	est save `using' ,replace
	est sto `using'_iv
	qui reg `y' `z' `x' ,robust
	est sto `using'_red

	tempvar d
	qui foreach v in b se bred sered ownB ownF N Ncomp y0mean w1 `d' {
		g `v'=.
	}

	levelsof f0 ,local(f0s)
	levelsof f1 ,local(f1s)

	qui foreach f of local f1s {
		replace `d' = `y'*(f!=`f')
		if "`y0'"=="y0" { 
			ivregress 2sls `d' (`t' = `z')  `x' ,robust
			est sto y0
		}

		foreach f0 of local f0s {
			if `f'==`f0' continue
			
			count if f1==`f' & f0==`f0' 
			replace N = r(N) if f==`f' & f0==`f0'

			* 2SLS estimates
			if "`e(_estimates_name)'"!="`using'_iv" est restore `using'_iv
			lincom `f0'.f0#`f'.f - `f0'.f0#`f0'.f
			replace b = r(estimate) if f==`f' & f0==`f0'
			replace se = r(se) if f==`f' & f0==`f0'
			
			if "`y0'"=="" & "`n'"=="" continue 
			
			* 1st stage
			replace `d' = (f==`f') & (f0==`f0')
			reg `d' `z' `x' ,robust
			replace ownB = _b[`f0'.f0#`f'.f1#c.z1] if f==`f' & f0==`f0'
			test `f0'.f0#`f'.f1#c.z1
			replace ownF = r(F) if f==`f' & f0==`f0'
			replace Ncomp = N*_b[`f0'.f0#`f'.f1#c.z1] if f==`f' & f0==`f0'

			if "`y0'"=="" continue 
			
			* Reduced form
			est restore `using'_red
			replace bred = _b[`f0'.f0#`f'.f1#c.z1] if f==`f' & f0==`f0'
			replace sered = _se[`f0'.f0#`f'.f1#c.z1] if f==`f' & f0==`f0'
					
			* y0
			est restore y0
			lincom `f0'.f0#`f'.f - `f0'.f0#`f0'.f
			replace y0mean = -r(estimate)  if f==`f' & f0==`f0'
					
			* w1
			replace `d' = (f==`f')*(f0==`f0')
			ivregress 2sls `d' (ib(`f0').f = f1#c.z1) `x' ,robust
			replace w1 = _b[`f'.f]  if f==`f' & f0==`f0'	
		}
	}

	keep f f0 b-w1
	bysort f f0: keep if _n==1
	qui compress
	save `using' ,`replace'
	restore
end

set  matsize 10000
use data ,clear

local zs f0#f1#c.z1
local xs c.gpa ib(20).age ib(2002).appyear ib(0).female

* Baseline estimates
qui ivregress 2sls f8yrc (f0#f = `zs') i.f0##(`xs') i.f1 if sample ,robust
qui EstSave using res_baseline ,replace y0 

* Log earnings
qui ivregress 2sls lnf8yrc (f0#f = `zs') i.f0##(`xs') i.f1 if sample & f8yrc>0 ,robust
qui EstSave using res_logearnings ,replace n

* Controlling for peer quality 
qui ivregress 2sls f8yrc (f0#f = `zs') i.f0##(`xs' c.peer_pred) i.f1 if sample ,robust
qui EstSave using res_peers ,replace 

* Controlling for predicted experience
qui ivregress 2sls f8yrc (f0#f = `zs') i.f0##(`xs' c.pred_exp) i.f1 if sample ,robust
qui EstSave using res_exp ,replace 

* Including non-completers
g f_99 = f==99
qui ivregress 2sls f8yrc (f0#i(1/10).f = `zs') i.f0##(`xs' f_99) i.f1 if f8yrc<. & f0<10 ,robust
qui EstSave using res_nocollege ,replace 

* Instrumenting institutions
qui ivregress 2sls f8yrc (f0#f ib(47).inst_compl = `zs' i.inst_pred) i.f0##(`xs') i.f1 i.inst_f1 i.inst_f0 if sample ,robust
qui EstSave using res_institutions ,replace

* Instrumenting institutions, log earnings
qui ivregress 2sls lnf8yrc (f0#f ib(47).inst_compl = `zs' i.inst_pred) i.f0##(`xs') i.f1 i.inst_f1 i.inst_f0 if sample ,robust
qui EstSave using res_log_inst ,replace
