use data ,clear
rename (f1 f0 f field_det_f1 field_det_f0 f8field_comp_det) (field_agg_f1 field_agg_f0 f8field_comp_agg f1 f0 f)
local n = 50
local change = 1 
cap drop n`n'
qui g n`n'=.
keep if sample==1
qui while `change' {
	bys f1 f0 : replace n`n' = _N>`n'
	cap drop sample`n'
	bys f  f0 : egen sample`n' = max(cond(f==f1 | f==f0, n`n', 0))
	noi count if !(sample`n' & n`n')
	local change r(N)
	keep if sample`n' & n`n'
}
qui tab age, g(Dage)
qui tab appyear, g(Dyear)

sort f1
tempfile fil
save `fil'
local xs gpa female Dage* Dyear*

xtdata `y' `xs' ,fe i(f1) clear
merge 1:1  _n using `fil' ,nogen

g bdet = .
g lnbdet = .
levelsof f0 ,local(f0s)
qui foreach f0 of local f0s {
	foreach y in "" ln {
		cap ivregress 2sls `y'f8yrc (ib(`f0').f = f1#c.z1) `xs' if f0==`f0' ,robust
		if _rc continue
		
		levelsof f if e(sample) & f!=`f0' ,local(fs)
		foreach f of local fs {
			replace `y'bdet = _b[`f'.f] if e(sample) & f==`f' 
		}
	}
}


collapse (count) n_bdet=bdet n_lnbdet=lnbdet (mean) *bdet ,by(f f0)

* Figure B.Va
append using res_baseline  ,gen(agg)
twoway (kdensity b [aw=N] if abs(b)<150 ,lp(dash)) ///
	(kdensity bdet [aw=n_bdet] if abs(bdet)<150 ,lp(longdash)) ///
	,xli(0) xti("Estimated payoff") xla(-150(50)150) name(Fig_BVa, replace) ///
	legend(label(1 "Baseline estimates") label(2 "Payoffs to subfields"))

* Figure B.Vb
keep if agg==0
keep f0-lnbdet
append using res_logearnings ,gen(agg)
keep f0 f n_* *bdet b N agg
tempfile file
save `file'
rename (*) =0
rename (f00 agg0) (f agg)
merge 1:1 agg f f0 using `file'
g s  = b+b0
g nt = N+N0
g sd = lnbdet+lnbdet0
g ntd= n_lnbdet+ n_lnbdet0
twoway (kdensity s [aw=nt] if abs(s)<2 ,lp(dash)) ///
	(kdensity sd [aw=ntd] if abs(sd)<2 ,lp(longdash)) ///
	,xli(0) xti("Estimated payoff") xla(-2(1)2) name(Fig_BVb, replace) ///
	legend(label(1 "Baseline estimates") label(2 "Payoffs to subfields"))

