use data ,clear
keep if sample

* restrict sample: keep only pred inst*f0*f1 cells 
* whith a certain #obs both with z1=1 and z1=0
bysort inst_pred f0 f1 z1 : g n=_N
bysort inst_pred f0 f1 z1 : g i=_n==1
egen ni   = sum(i) ,by(inst_pred f0 f1)
egen nmin = min(cond(ni==2,n,0)) ,by(inst_pred f0 f1)
keep if nmin >9

* restrict sample to cells with instrument or completed=f0
preserve
keep inst_pred f0 f1
bysort inst_pred f0 f1: keep if _n==1
rename f1 f
tempfile list 
save `list'
restore 
merge m:1 inst_pred f f0 using `list' , gen(_mz)
keep if (_mz==3 | f==f0)

* Expand for estimation of baseline payoffs in non-separability sample
expand 2
g cip = inst_pred
label val cip inst_f1
bysort fnr : replace inst_pred = 0 if _n==1

* iterate over predicted inst, estimate and store pred inst-specific returns
levelsof inst_pred ,local(ips)
qui foreach y in f8yrc /* lnf8yrc */ {
	g `y'_b =.
	g `y'_se =.
	qui foreach ip of local ips {
		local if if inst_pred==`ip'
		* finds the relevant fields, within pred inst, creates dummies and estimates pay-offs
		levelsof f  `if',local(fs)
		levelsof f0 `if',local(f0s)
		qui foreach f1 of local fs {
			foreach f0 of local f0s {
				count `if' & f0==`f0' & f==`f1' 
				if !r(N) | `f0'==`f1' continue
				g f0_`f0'__f_`f1'_  = f0==`f0' & f==`f1'
				g z_f0_`f0'__f1_`f1'_ = f0==`f0' & f==`f1' & z1
			}
		}
		cap ivregress 2sls `y' (f0_*__f_*_ = z_f0_*__f1_*_) ib(1).f0##c.(gpa female i.appyear i.age i.cip) i.f1 `if' ,robust
		if _rc {
			drop *f0_*__f*_*
			continue
		}
		
		foreach f of local fs {
			foreach f0 of local f0s {
				cap replace `y'_b  = _b[f0_`f0'__f_`f'_] `if' & f0==`f0' & f==`f'
				cap replace `y'_se = _se[f0_`f0'__f_`f'_] `if' & f0==`f0' & f==`f'
			}
		}
		drop *f0_*__f*_*
	}
	bysort f f0 (inst_pred): g `y'_b0 = `y'_b[1]
	bysort f f0 (inst_pred): g `y'_se0 = `y'_se[1]
}

drop if inst_pred==0
bysort inst_pred f0 f: keep if _n==1
keep inst_pred f0 f *f8yrc_*

local s1 f#f0
local s2 i.inst_pred
local s3 f#f0 i.inst_pred
forvalues i=1/3 {
	qui reg f8yrc_b `s`i'' [aw=1/f8yrc_se^2]
	cap testparm f#f0 
	if !_rc estadd scalar F_f = r(F)
	cap testparm i.inst_pred 
	if !_rc estadd scalar F_i = r(F)
	est sto e`i'
}
