use data,clear
keep if sample

reg f8yrc ib(4).f ,robust
est sto raw
reg f8yrc ib(4).f i.age i.appyear female gpa i.f1 ,robust
est sto ols
ivregress 2sls f8yrc (ib(4).f = f1#c.z1) i.age i.appyear female gpa i.f1 ,robust
est sto iv

use res_baseline ,clear
levelsof f,local(fs)
levelsof f0 ,local(f0s)
qui foreach x in raw ols iv {
	est restore `x'
	g b_`x' = .
	g se_`x' = .
	g d_`x' = .
	
	foreach f0 of local f0s {
		foreach f of local fs {
			if `f'==`f0' continue
			lincom `f'.f - `f0'.f
			replace b_`x' = r(estimate) if f==`f' & f0==`f0'
			replace se_`x' = r(se) if f==`f' & f0==`f0'
			replace d_`x' = b_`x'-b if f==`f' & f0==`f0'
		}
	}
}

* Figure BII
replace d_iv = -d_iv
reg d_iv b [aw=1/(se_iv^2+se^2)]
predict hat
corr d_iv b [aw=1/(se_iv^2+se^2)]
twoway (line hat b b) (scatter d_iv b [aw=1/(se_iv^2+se^2)] ,m(oh)) ///
	if max(abs(d_iv),abs(b))<100 ///
	,note("corr=`: di %6.4f r(rho)'") aspect(1) name(Figure_BII,replace) 

* Figure BIII
replace d_iv = -d_iv
twoway  (kdensity d_raw [aw=Ncomp] if abs(d_raw)<100) ///
	(kdensity d_ols [aw=Ncomp] if abs(d_ols)<100) /// 
	(kdensity d_iv  [aw=Ncomp] if abs(d_iv)<100) ,name(Figure_BIII,replace)
